<?php

add_action('inbound_store_lead_pre','wp_cta_set_conversion',10,1);
function wp_cta_set_conversion($data)
{
	$raw_post_values = json_decode( stripslashes($data['form_input_values']) , true);

	if (!isset($raw_post_values['wp_cta_id'])) {
		return;
	}
	
	$cta_id = $raw_post_values['wp_cta_id'];
	$vid = $raw_post_values['wp_cta_vid'];	

	$lp_conversions = get_post_meta( $cta_id , 'wp-cta-ab-variation-conversions-'.$vid, true );
	$lp_conversions++;
	update_post_meta(  $cta_id , 'wp-cta-ab-variation-conversions-'.$vid, $lp_conversions );

	
}

function wp_cta_get_page_views($cta_id){
    $count_key = 'wp_cta_page_views_count';
    $count = get_post_meta($cta_id, $count_key, true);
    if($count==''){
        delete_post_meta($cta_id, $count_key);
        add_post_meta($cta_id, $count_key, '0');
        return;
   }
   return $count;
}

function wp_cta_set_page_views($cta_id) {
    $count_key = 'wp_cta_page_views_count';
    $count = get_post_meta($cta_id, $count_key, true);
    if($count==''){
        $count = 0;
        delete_post_meta($cta_id, $count_key);
        add_post_meta($cta_id, $count_key, '0');
    }else{
        $count++;
        update_post_meta($cta_id, $count_key, $count);
    }
}

function wp_cta_get_conversions($cta_id){
    $count_key = 'wp_cta_page_conversions_count';
    $count = get_post_meta($cta_id, $count_key, true);
    if($count==''){
        delete_post_meta($cta_id, $count_key);
        add_post_meta($cta_id, $count_key, '0');
        return "0";
   }
   return $count;
}



function wp_cta_get_useragent_whitelist()
{
	$useragent[] = 'msie';
	$useragent[] = 'firefox';
	$useragent[] = 'webkit';
	$useragent[] = 'opera';
	$useragent[] = 'netscape';
	$useragent[] = 'konqueror';
	$useragent[] = 'gecko';
	$useragent[] = 'chrome';
	$useragent[] = 'songbird';
	$useragent[] = 'seamonkey';
	$useragent[] = 'flock';
	$useragent[] = 'AppleWebKit';
	$useragent[] = 'Android';
	$useragent[] = 'Lynx';
	$useragent[] = 'Dillo';
	
	return $useragent;
}

function wp_cta_determine_spider()
{
	if (isset($_SERVER['HTTP_USER_AGENT']))
	{
		$visitor_useragent = strtolower($_SERVER['HTTP_USER_AGENT']);
		$visitor_ip = $_SERVER['REMOTE_ADDR'];
	}
	else
	{
		return 1;
	}
	
	//check to make sure useragent is present
	if ($visitor_useragent)
	{
		$useragents = wp_cta_get_useragent_whitelist();
		foreach ($useragents as $k=>$v) 
		{
			$v = trim($v);
			if ($v)
			{
				if(stristr($visitor_useragent, $v)||$v=='*')
				{
					return 0;
				}
			}
		}
	}
	
	return 1;
}